/**
 * @file body_temperature.h
 * @brief Body Temperature Module header
 *
 * Proyecto Smart Watch - Body Temperature
 * Body Temperature module
 *
 * This module is used to get the body temperature of the user
 *
 * body_temperature.h
 * Module that provides the body temperature of the user
 *
 * @authors Leonardo Martínez <leonardo.martinez.hornak@fing.edu.uy>, Isabel Morales <imorales@fing.edu.uy>
 * @version 1.0
 * @date May 15, 2021
 */

#ifndef INCLUDE_BODY_TEMPERATURE_H_
#define INCLUDE_BODY_TEMPERATURE_H_

/**
 * @brief Initializes the module (eg. set function callback to be called when a new temperature reading is available
 *
 */
void initializeBodyTemperature(void);

/**
 * @brief Obtains the last temperature reading in milicelsius
 * @return int temperature in celsius degrees divided by 1000
 *
 */
int getLastTemperatureReading(void);

#endif /* INCLUDE_BODY_TEMPERATURE_H_ */
