/**
 * @file fifo_function_queue.h
 * @brief Laboratorio 4 - Sistemas Embebidos - Fing
 * 8-BIT FIFO FUNCTION QUEUE MODULE
 *
 * @author Leonardo Martínez <leonardo.martinez.hornak@fing.edu.uy>, Isabel Morales <imorales@fing.edu.uy>
 * @version 1.0
 * @date 1/4/2021
 */

#ifndef INCLUDE_FIFO_FUNCTION_QUEUE_H_
#define INCLUDE_FIFO_FUNCTION_QUEUE_H_

/**
* Constants shared with other modules
*/

//#define  FUNCTION_QUEUE_DIMENSION 20

//Assert test 1
#define  FUNCTION_QUEUE_DIMENSION 2

/**
 * @brief Initializes head and tail
 */
void initFunctionQueue(void);

/**
 * @brief Indicates if queue is empty
 * @return char Outputs 1 if queue is empty
 */
char functionQueueIsEmpty(void);

/**
 * @brief Indicates if queue is full
 * @return char Outputs 1 if queue is full
 */
char functionQueueIsFull(void);

/**
 * @brief Adds function pointer value to queue
 * @param void* value: value to be added
 */
void addToFunctionQueue(void* value);

/**
 * @brief Returns a char value from the fifo queue
 * @return void* value that was stored in the queue
 */
void* getFromFunctionQueue(void);

#endif // INCLUDE_FIFO_FUNCTION_QUEUE_H_
