#include "msp.h"
#include "fifo_function_queue.h"
#include "user_interface.h"
#include "gpio.h"
#include "body_temperature.h"
#include "communications.h"

void (*task)();

/**
 * main.c
 */

void main(void)
{
	volatile int i;
    WDT_A->CTL = WDT_A_CTL_PW | WDT_A_CTL_HOLD;		// stop watchdog timer

    //TODO Remove - Crystal configuration

    //Basic Clock System Control Register 1 - Turn off XT2 / ACLK Divider = 1
    BCSCTL1 = XT2OFF | DIVA_0;

    //Basic Clock System Control Register 3 - Use external  32768 Hz crystal for ACLK / capacitance of 12.5pF
    BCSCTL3 = LFXT1S_0 | XCAP_3;

    initFunctionQueue();
    initializeGPIOModule();
    initializeUserInterface();
    initializeBodyTemperature();
    initializeCommunications();

    __enable_interrupt();

	while(1)
    {
        if(!functionQueueIsEmpty())
        {
            task = getFromFunctionQueue();
            task();
        }
        else
        {
            __low_power_mode_3();
        }
    }

}
